#ifndef __STRING__H__
#define __STRING__H__
typedef int size_t;

/* returning a destination string */
void *memset(void *destination, int c, size_t size);
 
/* returning a destination string */
void *memcpy(void *destination, const void *source, size_t size);
 
/* returning a difference of 0 if no */
int memcmp(const void *m1, const void *m2, size_t size);
 
/* This function moves size characters from the block of memory starting
       at `*source' to the memory starting at `*dest'.  `memmove'  reproduces  the
       characters correctly at `*dest' even if the two areas overlap. */
void *memmove(void *dest, const void *source, size_t size);

/* copies string pointed to by src (including the terminating null character)  to the array pointed to by dst. Returns dst */
void* strcpy(char* dst, const char* src);

/* copies  not  more than LENGTH characters from the the string pointed to by SRC (including the terminating  null  character)  to  the
       array  pointed  to  by DST. Returns dst */
void* strncpy(char* dst, const char* src, size_t length);

/* `strcmp' compares the string at A to the string at B. If  `*A'  sorts lexicographically after `*B', `strcmp' returns a number
       greater than zero.  If the two strings match,  `strcmp'  returns  zero.
       If  `*A' sorts lexicographically before `*B', `strcmp' returns a number
       less than zero.*/
int strcmp(const char *A, const char *B);
 
/* strncmp analog strcmp, but it compares first  LENGTH characters */
int strncmp(const char *A, const char * B, size_t LENGTH);

/* strcat'  appends a copy of the string pointed to by SRC (including the
       terminating null character) to the end of the string pointed to by DST.
       The  initial  character of SRC overwrites the null character at the end
       of DST.*/
char *strcat(char *DST, const char *SRC);

/* analog 'strcat', but it appends maximum LENGTH characters */
char *strncat(char *DST, const char *SRC, size_t LENGTH);

/*This  function  finds the first occurence of C (converted to a char) in
       the string pointed to by STRING (including the terminating null charac-
       ter). Returns a pointer to the located character, or a null pointer if C does
       not occur in STRING.*/
char* strchr(const char *STRING, int C);

/* This function is analog strchr, but finds C from the end */
char * strrchr(const char *STRING, int C);

/* Locates  the  first  occurence  in  the  string pointed to by S1 of the
       sequence of characters in the string pointed to by  S2  (excluding  the
       terminating null  character). */
char *strstr(const char *S1, const char *S2);

/* returns the characters count */
size_t strlen(const char *STR);

#endif
