.text

# void *memset(void *destination, int c, size_t size)
.globl _memset
_memset:

cld						# increment edi (flag d = 0) 
movl 12(%esp), %ecx		# ecx = size 
movb 8(%esp), %al		# esi = (char) c 
movl 4(%esp), %edi		# edi = destination 
movl %edi, %ebx			# ebx = edi 
rep stosb				# copy  al into  [edi++]   ecx count 
movl %ebx, %eax			# return destination 
ret


# void *memcpy(void *destination, const void *source, size_t size)
.globl _memcpy
_memcpy:
cld						# increment edi, esi (flag d = 0) 
movl 12(%esp), %eax		# eax = size
xorl %edx, %edx
movl $4, %esi
divl %esi
movl %eax, %ecx			# set counter
movl 8(%esp), %esi		# esi = source 
movl 4(%esp), %ebx		# save return destination 
movl %ebx, %edi			# edi = destination 
rep movsd				# copy  [esi+=4] -> [edi+=4]   ecx count 
movl %edx, %ecx
rep movsb				# copy remainder
movl %ebx, %eax
ret

# int memcmp(const void *m1, const void *m2, size_t size)
.globl _memcmp
_memcmp:
cld						# increment edi (flag d = 0)
xorl %edx, %edx			# set eflags: if size==0 then return 0
movl $4, %esi
movl 12(%esp), %eax		# ecx = size
divl %esi
movl 8(%esp), %edi		# edi = m2
movl 4(%esp), %esi		# esi = m1
movl %eax, %ecx
repe cmpsd
jne __L
movl %edx, %ecx
repe cmpsb				# compare [esi++] -> [edi++] ,  ecx count, while equal strings
__L:
setl %al
roll $31, %eax			# if m1 < m2 then eax = -value else eax = 0
setg %al				# if m1 > m2 then eax = 1 else eax = 0
ret

# void *memmove(void *dst, const void *src, size_t size)
/* {
 if(src>dst){
  void* x = dst;
  while(size--) *dst++ = *src++;
  return x;
 }
 
 dst = dst + size - 1;
 src = src + size - 1;

 while (size--) *dst-- = *src--;
 return dst;
}*/

.globl _memmove
_memmove:
movl 4(%esp), %edi		# edi = dst
movl 8(%esp), %esi		# esi = src
movl 12(%esp), %ecx		# ecx = size
movl %edi, %eax
cld
cmp %edi, %esi
je __R_memmove			# return
jg __L_memmove
std						# decrement in movsb
leal -1(%edi, %ecx), %edi	# edi = edi + ecx - 1
leal -1(%esi, %ecx), %esi	# esi = esi + ecx - 1
__L_memmove:
rep movsb
__R_memmove:
ret

# void* strcpy(char* dst, const char* src)
.globl _strcpy
_strcpy:
cld						# increment edi, esi (flag d = 0) 
movl 8(%esp), %esi		# esi = src 
movl 4(%esp), %ebx		# save return destination 
movl %ebx, %edi			# edi = dst
__repeat_strcpy:
lodsb					# load [esi++]->eax
stosb					# save eax->[edi++]
test %al, %al
jnz __repeat_strcpy
movl %ebx, %eax
ret

# void* strncpy(char* dst, const char* src, size_t length)
.globl _strncpy
_strncpy:
movl 12(%esp), %ecx		# eax = length
test %ecx, %ecx
jz __exit_strncpy
movl 8(%esp), %esi		# esi = src 
movl 4(%esp), %ebx		# save return destination 
movl %ebx, %edi			# edi = dst
__repeat_strncpy:
lodsb					# load [esi++]->eax
stosb					# save eax->[edi++]
test %al, %al
jz __exit_strncpy
loop __repeat_strncpy
xorl %eax, %eax
stosb
__exit_strncpy:
movl %ebx, %eax
ret

# int strcmp(const char *A, const char *B)
.globl _strcmp
_strcmp:
cld						# increment edi, esi (flag d = 0) 
movl 8(%esp), %esi		# esi = B
movl 4(%esp), %edi		# edi = A
xorl %eax, %eax			# set eflags: if size==0 then return 0
__repeat_strcmp:
lodsb					# load [esi++]->eax
scasb					# compare eax, [edi++]
jne __exit_strcmp
test %al, %al
jnz __repeat_strcmp
__exit_strcmp:
setl %al
roll $31, %eax			# if m1 < m2 then eax = -value else eax = 0
setg %al				# if m1 > m2 then eax = 1 else eax = 0
ret

# int strncmp(const char *A, const char * B, size_t LENGTH)
.globl _strncmp
_strncmp:
cld						# increment edi, esi (flag d = 0) 
movl 12(%esp), %ecx		# ecx = LENGTH
test %ecx, %ecx			# set eflags: if size==0 then return 0
jz __exit_strncmp
movl 8(%esp), %esi		# esi = B
movl 4(%esp), %edi		# edi = A
xorl %eax, %eax
__repeat_strncmp:
lodsb					# load [esi++]->eax
scasb					# compare eax, [edi++]
jne __exit_strncmp
test %al, %al
jz __exit_strncmp
loop __repeat_strncmp
__exit_strncmp:
setl %al
roll $31, %eax			# if m1 < m2 then eax = -value else eax = 0
setg %al				# if m1 > m2 then eax = 1 else eax = 0
ret

# char *strcat(char *DST, const char *SRC)
.globl _strcat
_strcat:
cld
movl 4(%esp), %edi		# edi = DST
movl 8(%esp), %esi		# esi = SRC
movl %edi, %ebx
xorl %eax, %eax
__repeat_strcat:
scasb
jne __repeat_strcat		# while not null
dec %edi
__repeat2_strcat:
lodsb
stosb
test %al, %al
jne __repeat2_strcat
movl %ebx, %eax
ret

# char *strncat(char *DST, const char *SRC, size_t LENGTH)
.globl _strncat
_strncat:
cld
movl 12(%esp), %ecx		# esi = LENGTH
test %ecx, %ecx
jz __exit_strncat
movl 8(%esp), %esi		# esi = SRC
movl 4(%esp), %edi		# edi = DST
movl %edi, %ebx
xorl %eax, %eax
__repeat_strncat:
scasb
jne __repeat_strncat
dec %edi
__repeat2_strncat:
lodsb
stosb
test %al, %al
je __exit_strncat
loop __repeat2_strncat
xorl %eax, %eax
stosb
__exit_strncat:
movl %ebx, %eax
ret

# char* strchr(const char *STRING, int C)
.globl _strchr
_strchr:
cld
movl 4(%esp), %esi		# esi = STRING
movb 8(%esp), %bl		# bl = (char) C
__repeat_strchr:
lodsb
cmp %al, %bl
je __eq_strchr
test %al, %al
jne __repeat_strchr
xorl %eax, %eax
ret
__eq_strchr:
movl %esi, %eax
dec %eax
ret

# char* strrchr(const char *STRING, int C)
.globl _strrchr
_strrchr:				# it not read STRING twice
cld
movl 4(%esp), %esi		# esi = STRING
movb 8(%esp), %bl		# bl = (char) C
xorl %edx, %edx			# return null if not detect C in STRING
__repeat_strrchr:
lodsb
cmp %al, %bl
je __eq_strrchr
test %al, %al			
jnz __repeat_strrchr	# if not null-character
movl %edx, %eax
ret
__eq_strrchr:
movl %esi, %edx			# save pointer by equal character
jmp __repeat_strrchr

# char *strstr(const char *S1, const char *S2)
.globl _strstr
_strstr:
cld
movl 4(%esp), %esi		# esi = S1
movl 8(%esp), %edx		# edx = S2
pushl %ebp
movl %edx, %edi
xorl %eax, %eax
__repeat_strstr:
scasb
jnz __repeat_strstr
subl %edx, %edi
decl %edi				# edi = length S2
movl %edi, %ebp
movb (%edx), %bl		# bl = *S2
inc %edx				# first character from S2 will by found
repeat_strstr:
lodsb					# find first character from S2 in S1
cmp %al, %bl
je test_strstr
test %al, %al
jnz repeat_strstr
xorl %eax, %eax			# S2 not found in S1
popl %ebp
ret
test_strstr:
movl %ebp, %ecx
movl %edx, %edi
movl %esi, %eax				# if not found S2 in S1 then renew "repeat_strstr"
repe cmpsb
test %ecx, %ecx
jz __exit_strstr
movl %eax, %esi				# renew
jmp repeat_strstr
__exit_strstr:
dec %eax
popl %ebp
ret

# size_t strlen(const char *STR)
.globl _strlen
_strlen:
cld
movl 4(%esp), %edi		# edi = STR
movl %edi, %ebx
xorl %eax, %eax
__repeat_strlen:
scasb
jne __repeat_strlen
subl %ebx, %edi
movl %edi, %eax
decl %eax
ret
